local format = string.format
local table_concat = table.concat
local table_insert = table.insert

local broker = LibStub("LibDataBroker-1.1")

local SysMon = broker:NewDataObject("Broker_SysMon")
LibStub("AceTimer-3.0"):Embed(SysMon)

SysMon.icon = "Interface\\AddOns\\Broker_SysMon\\icon.tga"
SysMon.info = {}
SysMon.unit = {"fps","ms","MiB","KiB/s"}
SysMon.label = "SysMon"

local initialMemory, currentMemory, mem1, mem2, mem3, mem4, mem5, mem6, mem7, mem8, mem9, mem10
local timeSinceLastUpdate, justEntered, gcTime

function SysMon:OnUpdate()
	if not timeSinceLastUpdate then
		timeSinceLastUpdate = 0
	end
	timeSinceLastUpdate = timeSinceLastUpdate + 1

	if justEntered then
		if timeSinceLastUpdate >= 10 then
			initialMemory = collectgarbage('count')
			currentMemory = initialMemory
			mem1 = currentMemory
			mem2 = currentMemory
			mem3 = currentMemory
			mem4 = currentMemory
			mem5 = currentMemory
			mem6 = currentMemory
			mem7 = currentMemory
			mem8 = currentMemory
			mem9 = currentMemory
			mem10 = currentMemory
			justEntered = false
		end
	else
		mem1, mem2, mem3, mem4, mem5, mem6, mem7, mem8, mem9, mem10 =
			currentMemory, mem1, mem2, mem3, mem4, mem5, mem6, mem7, mem8, mem9
		currentMemory = collectgarbage('count')
		self:Update()
	end

	if timeSinceLastUpdate >= 10 then
		timeSinceLastUpdate = nil
	end
end

local t = {}
local info = SysMon.info
function SysMon:Update()
	if not mem10 then
		mem10 = currentMemory
	end
	local currentRate = (currentMemory - mem10) / 10

	local framerate = floor(GetFramerate() + 0.5)
	local latency = select(3, GetNetStats())
	
	info[1] = framerate
	info[2] = latency
	info[3] = format("%.1f|r", currentMemory / 1024)
	info[4] = format("%.1f|r", currentRate)
	
	for k, v in ipairs(info) do
		t[k] = string.format("%s %s", v, self.unit[k])
	end
	
	self.text = table_concat(t, " ")
end

initialMemory = collectgarbage('count')
currentMemory = initialMemory
mem1 = currentMemory
mem2 = currentMemory
mem3 = currentMemory
mem4 = currentMemory
mem5 = currentMemory
mem6 = currentMemory
mem7 = currentMemory
mem8 = currentMemory
mem9 = currentMemory
mem10 = currentMemory
timeSinceLastUpdate = 0
justEntered = true
gcTime = time()
SysMon:ScheduleRepeatingTimer("OnUpdate", 1)

SysMon:Update()